<template>
  <div class="container">
    <div class="row justify-content-center">
      <div class="col-md-8">
        <div class="card">
          <div class="card-header">Dropdown</div>

          <div class="card-body">
            <div class="form-group">
              <label>Main category:</label>

              <v-select
                label="value"
                placeholder="Main category"
                v-model="category"
                :reduce="(cate) => cate.key"
                :options="categories"
                @input="getSubCategories($event)"
              />
            </div>
            <div class="form-group" v-show="seenSub">
              <label>Sub category:</label>
              <v-select
                label="value"
                placeholder="Main category"
                v-model="subcategory"
                :reduce="(subcate) => subcate.key"
                :options="subcategories"
                @input="getproperties($event)"
              />
            </div>
            <div class="form-group properties" v-show="seenProperties">
              <label>Process Type:</label>
              <v-select
                label="value"
                placeholder="Process"
                v-model="property"
                :reduce="(propert) => propert.key"
                :options="properties"
                @input="getBrands($event)"
              />
            </div>
            <div class="form-group properties" v-show="seenBrands">
              <label>Brand:</label>
              <v-select
                label="value"
                placeholder="Process"
                v-model="brand"
                :reduce="(bran) => bran.key"
                :options="brands"
                @input="getModel($event)"
              />
            </div>
            <div class="form-group properties" v-show="seenModel">
              <label>Model:</label>
              <v-select
                label="value"
                placeholder="Process"
                v-model="model"
                :reduce="(mode) => mode.key"
                :options="models"
                @input="getType($event)"
              />
            </div>
            <div class="form-group properties" v-show="seenType">
              <label>Type:</label>
              <v-select
                label="value"
                placeholder="Process"
                v-model="type"
                :reduce="(typ) => typ.key"
                :options="types"
              />
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>
   
<script>
import vSelect from "vue-select";
import "vue-select/dist/vue-select.css";

Vue.component("v-select", vSelect);

export default {
  data() {
    return {
      category: "Main category",
      categories: [],
      subcategory: "Sub category",
      property: "Process Type",
      seenSub: false,
      seenProperties: false,
      seenBrands: false,
      seenModel: false,
      seenType: false,
      brand: "Brand",
      model: "Model",
      type: "Type",
      subcategories: [],
      brands: [],
      models: [],
      types: [],
      properties: [],
    };
  },
  methods: {
    getcategories: function () {
      axios.get("/api/getcategories").then((response) =>
        (this.categories = _.map(response.data.data.categories, (cate) => ({
          key: cate.id,
          value: cate.name,
        }))).bind(this)
      );
    },
    getSubCategories: function () {
      axios
        .get("/api/getSubcategory", {
          params: {
            category_id: this.category,
          },
        })
        .then((response) =>
          ((this.subcategories = _.map(response.data, (subcate) => ({
            key: subcate.id,
            value: subcate.name,
          }))),
          Object.keys(response.data).length === 0
            ? ((this.seenSub = false),
              (this.seenProperties = false),
              (this.seenBrands = false),
              (this.seenModel = false),
              (this.seenType = false))
            : (this.seenSub = true))
        );
    },
    getproperties: function () {
      axios
        .get("/api/getproperties", {
          params: {
            child_id: this.subcategory,
            parent_id: this.category,
          },
        })
        .then((response) =>
          ((this.properties = _.map(response.data, (propert) => ({
            key: propert.id,
            value: propert.name,
          }))),
          Object.keys(response.data).length === 0
            ? ((this.seenProperties = false),
              (this.seenBrands = false),
              (this.seenModel = false),
              (this.seenType = false),
              (this.seenModel = false))
            : (this.seenProperties = true))
        );
    },
    getBrands: function () {
      axios
        .get("/api/getBrands", {
          params: {
            child_id: this.subcategory,
            property_id: this.property,
          },
        })
        .then((response) =>
          ((this.brands = _.map(response.data, (bran) => ({
            key: bran.id,
            value: bran.name,
          }))),
          Object.keys(response.data).length === 0
            ? ((this.seenBrands = false),
              (this.seenModel = false),
              (this.seenType = false))
            : (this.seenBrands = true))
        );
    },
    getModel: function () {
      axios
        .get("/api/getModel", {
          params: {
            brand_id: this.brand,
          },
        })
        .then((response) =>
          ((this.models = _.map(response.data, (mode) => ({
            key: mode.id,
            value: mode.name,
          }))),
          Object.keys(response.data).length === 0
            ? ((this.seenModel = false), (this.seenType = false))
            : (this.seenModel = true))
        );
    },
    getType: function () {
      axios
        .get("/api/getType", {
          params: {
            brand_id: this.brand,
            model_id: this.model,
          },
        })
        .then((response) =>
          ((this.types = _.map(response.data, (typ) => ({
            key: typ.id,
            value: typ.name,
          }))),
          Object.keys(response.data).length === 0
            ? (this.seenType = false)
            : (this.seenType = true))
        );
    },
  },
  created: function () {
    this.getcategories();
  },
};
</script>
